# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Sub-Identify
Version:	0.14
Release:	22.%{__distinit}%{__distvers}
Summary:	Retrieve names of code references
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Sub-Identify
Source0:	https://cpan.metacpan.org/modules/by-module/Sub/Sub-Identify-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(B)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(XSLoader)
# Test Suite
%if 0%{?fedora} > 21 || 0%{?rhel} > 7
BuildRequires:	perl(feature)
%endif
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(warnings)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(B)
Requires:	perl(XSLoader)

# Don't provide private perl libs
%{?perl_default_filter}

%description
Sub::Identify allows you to retrieve the real name of code references. For
this, it uses Perl's introspection mechanism, provided by the B module.

%prep
%setup -q -n Sub-Identify-%{version}

# Fix script interpreters
perl -pi -e 's|^#!perl|#!/usr/bin/perl|' t/*

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README.mdown TODO.mdown t/
%{perl_vendorarch}/auto/Sub/
%{perl_vendorarch}/Sub/
%{_mandir}/man3/Sub::Identify.3*

%changelog
* Mon Apr  3 2023 Paul Howarth <paul@city-fan.org> - 0.14-22
- Use SPDX-format license tag

* Wed Jun  1 2022 Paul Howarth <paul@city-fan.org> - 0.14-19
- Perl 5.36 rebuild

* Fri May 21 2021 Paul Howarth <paul@city-fan.org> - 0.14-16
- Perl 5.34 rebuild

* Thu Jun 25 2020 Paul Howarth <paul@city-fan.org> - 0.14-13
- Perl 5.32 rebuild

* Fri May 31 2019 Paul Howarth <paul@city-fan.org> - 0.14-10
- Perl 5.30 rebuild

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 0.14-7
- Perl 5.28 rebuild

* Sun Aug  6 2017 Paul Howarth <paul@city-fan.org> - 0.14-4
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun  4 2017 Paul Howarth <paul@city-fan.org> - 0.14-2
- Perl 5.26 rebuild

* Tue Apr 11 2017 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Make tests pass without . in @INC (actual fix)

* Mon Apr  3 2017 Paul Howarth <paul@city-fan.org> - 0.13-1
- Update to 0.13
  - Reformatted Changes to follow basic format in CPAN::Changes::Spec
  - Make tests pass without . in @INC
- Drop support for EOL distributions prior to F-13:
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Sep 27 2016 Paul Howarth <paul@city-fan.org> - 0.12-4
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find commands using -empty and -delete

* Tue Sep  8 2015 Paul Howarth <paul@city-fan.org> - 0.12-1
- Update to 0.12
  - Fix build on perl 5.8

* Fri Sep  4 2015 Paul Howarth <paul@city-fan.org> - 0.11-1
- Update to 0.11
  - Add test for Perl's subroutine signatures feature (GH#5)
  - Do not let get_code_location() segfault on XSUBs
- BR: perl-devel for EXTERN.h
- Add patch to get build to work with Perl 5.8.x (CvISXSUB needs 5.10.x)

* Wed Jan  7 2015 Paul Howarth <paul@city-fan.org> - 0.10-1
- Update to 0.10
  - Fix test failure due to hard-coded filenames

* Thu Sep 18 2014 Paul Howarth <paul@city-fan.org> - 0.08-1
- Update to 0.08
  - Add test for function prototypes
  - Better, simpler code for testing if we can load the XS version
  - Add gitignore file
  - Experimental implementation of get_code_location
  - Add XS implementation of get_code_location()
  - Add test for the prototype of get_code_location
  - Make get_code_location work on undefined subs
  - Add link to github repo in the meta file
  - Add TODO file
  - Add pure-perl implementation of is_sub_constant()
  - Add XS implementation of is_constant_sub()
  - Add documentation
  - Skip tests that rely on perls more recent than 5.14.0
  - Update ppport.h
  - Use the pure-perl version of is_sub_constant on perls earlier than 5.16
  - Require B unconditionally on older perls
  - Require at least perl 5.8.0
  - Improve docs beyond a really terse synopsis
- Classify buildreqs by usage

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.04-21
- Drop %%defattr, redundant since rpm 4.4

* Sun Jul 21 2013 Paul Howarth <paul@city-fan.org> - 0.04-17
- Perl 5.18 rebuild

* Sat Jun 23 2012 Paul Howarth <paul@city-fan.org> - 0.04-14
- Perl 5.16 rebuild

* Mon Mar  5 2012 Paul Howarth <paul@city-fan.org> - 0.04-13
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.04-11
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 0.04-8
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 17 2010 Paul Howarth <paul@city-fan.org> - 0.04-7
- Fix dist tag for RHEL-6 Beta

* Fri Feb 12 2010 Paul Howarth <paul@city-fan.org> - 0.04-6
- Filter provides
- Dist tag for Rawhide no longer needs special-casing

* Mon Aug 10 2009 Paul Howarth <paul@city-fan.org> - 0.04-5
- Import from Fedora

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 11 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-2
- Aaaand change files to look in the the arch-dependent dirs

* Wed Feb 11 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-1
- Update to 0.04
- Drop buildarch noarch, as we have some XS bits now

* Wed May 28 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.03-1
- Update to 0.03

* Tue Mar 04 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.02-3
- Rebuild for new perl

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 0.02-2.2
- Add BR: perl(Test::More)

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 0.02-2.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Wed Sep 06 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-2
- Bump

* Tue Sep 05 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.02-1
- Specfile autogenerated by cpanspec 1.69.1
